SystemOrganization addCategory: #'Magritte-Scriptaculous'!

!MAColumn methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 3/17/2008 15:54'!
renderCell: anObject row: rowIndex column: colIndex on: html
	html tableData
		class: 'c', colIndex asString ;
		with: [
			self format valueWithArguments: ((Array with: anObject with: html with: rowIndex)
				first: self format numArgs) ]! !

!MAContainerDecoration methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 6/4/2008 01:13'!
renderContentOn: html

	"added an id for the form so that we can potentially trigger the form"
	
	html form
		class: 'magritte';
		id: (self component ajaxFormId);
		multipart: self isMultipart;
		defaultAction: [ self component perform: self default ];
		with: [ self renderOwnerOn: html; renderButtonsOn: html ]! !

MATextInputComponent subclass: #MAAutoCompletingTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAAutoCompletingTextInputComponent commentStamp: 'kph 1/10/2008 02:12' prior: 0!
At present we obtain the list from the model, via the accessor supplied at the accessor's, #options.

We can alternatively get it from the memento via a description obtained from the model class, #listDescriptionSelector

We also have an #inputExampleText property (as an addition to our superclass)

and #listMax

When completed we redraw our parent.!

!MAAutoCompletingTextInputComponent class methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 04:32'!
isAbstract

 ^ false! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/4/2008 23:08'!
exampleText

	^ self description propertyAt: #inputExampleText ifAbsent: ['']! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:49'!
filter
	" #left #right #substring (default) #match"
	
	^ self description propertyAt: #filter ifAbsent: [ #substring ]! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:01'!
isAutoSelect

	^ self description propertyAt: #autoSelect ifAbsent: false! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 07:51'!
isUpdating

	^ (self description accessor propertyAt: #update ifAbsent: [nil]) notNil! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/10/2008 03:55'!
left
	^ self list select: [ :each | (each asString findString: self string startingAt: 1 caseSensitive: false) = 1 ].! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/7/2008 02:36'!
list

	self listDescription ifNotNilDo: [ :desc | ^ self memento readUsing: desc  ].
	 
	^ self memento model readUsing: (MADescription basicNew accessor: (self description accessor options ifNil: [ ^ #() ]) ).
	
 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:23'!
listDescription

	^ self memento model class perform: (self listDescriptionSelector ifNil:[ ^nil ])! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:21'!
listDescriptionSelector

	^ self description propertyAt: #listDescriptionSelector ifAbsent: nil! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:35'!
listFiltered

	^ self perform: self filter! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:11'!
listMax
	^ self description propertyAt: #listMax ifAbsent: [ self listMaxDefault ]! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:12'!
listMaxDefault
	^  10! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/11/2008 12:29'!
match

	| match |
	
	match := ('*', self string ,'*') copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 4/16/2008 14:16'!
matchLeft

	| match |


	 	
	match := (self string ,'*') copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	
! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 4/10/2008 00:38'!
matchRight

	| match |
	
	match := ('*', self string) copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAAutoCompletingTextInputComponent methodsFor: 'rendering' stamp: 'kph 1/14/2008 07:51'!
renderEditorOn: html
	| input p whenSelected |
 
	p := self parent.
 
	input := self labelId.
	html textInput
		attributes: self attributes;
		id: input;
		value: self string;
		exampleText: self exampleText;
		"onChange: (html request
					triggerFormElement: input);"
		callback: [ :v | self string: v ].
	
	whenSelected := html request.
					
	self isUpdating ifTrue: [
		 
		whenSelected 
			triggerFormElement: input; 
			onSuccess: (html updater id: (p id); callback: [ :r | self log info: p id.  p updateContentOn: r] )
	].  
		
	html div 
		class: 'autocomplete';
		script: (html autocompleter
			element: input;
			autoSelect: self isAutoSelect;
			onSelected: whenSelected;
			on: #renderListOn: of: self)
		 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 4/16/2008 14:19'!
renderListOn: html

	| items |

	items := self listFiltered.

	html unorderedList list: (items first: (items size min: self listMax))! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/11/2008 12:29'!
right

	| match |
	
	match := ('*', self string) copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAAutoCompletingTextInputComponent methodsFor: 'rendering' stamp: 'kph 11/19/2007 22:19'!
style
	^ 'input#text {
	width: 250px;
}
div.autocomplete {
	position: absolute;
	background-color: white;
	border: 1px solid #888;
	margin: 0px;
	padding: 0px;
	z-index: 1000;
}
div.autocomplete ul, div.autocomplete ul li {
	list-style-type: none;
	line-height: 1.7;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul li.selected {
	background-color: #ffb;
}'! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/10/2008 03:56'!
substring
	^ self list select: [ :each | each asString includesSubstring: self string caseSensitive: false ].
	
 ! !

!MAFileModel class methodsFor: '*magritte-scriptaculous' stamp: 'kph 4/14/2008 15:36'!
descriptionFile
	 
	^ MAFileDescription new
		kind: self;
		reportColumnClass: MAColumnVisitor;
		accessor: #file;
		label: 'File';
		yourself! !

!MAFileModel methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/10/2008 12:04'!
file

	^ self! !

!BlockContext methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/6/2008 20:53'!
read: anObject description: aDescription

	^ self value: anObject! !

!BlockContext methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/6/2008 20:52'!
write: anObject description: aDescription

	^ self value: anObject! !

!MAComponentRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/31/2008 15:26'!
classFor: aDescription

	| classes item |

	item := (component description = aDescription 
		ifTrue: [ component ]
		ifFalse: [ self childAt: aDescription ]) ifNotNilDo: [ :comp | comp model ].
	
	classes := aDescription cssClassesForItem: item.

	(self hasError: aDescription)	ifTrue: [ classes add: 'error' ].

	^ classes reduce: [ :a :b | a , ' ' , b ]! !

!MAComponentRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 09:07'!
renderContainer: aDescription
	self visitAll: (aDescription select: [ :each |
		(each isVisibleForItem: component memento)
		and: [ each componentClass notNil ] ])! !

MAComponentRenderer subclass: #MADivsRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MADivsRenderer methodsFor: 'rendering' stamp: 'kph 4/4/2008 03:15'!
renderContainer: aDescription 
	html div
		class: ((self classFor: aDescription), ' clear');
		with: [super renderContainer: aDescription.
				 ]! !

!MADivsRenderer methodsFor: 'rendering' stamp: 'kph 4/1/2008 22:25'!
renderControl: aDescription
	html span
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!MADivsRenderer methodsFor: 'rendering' stamp: 'kph 4/1/2008 18:48'!
renderElement: aDescription
	html div
		class: (self classFor: aDescription);
	 	title: (aDescription tooltipForItem:  (self childAt: aDescription) model);
		with: [ super renderElement: aDescription ]! !

!MADivsRenderer methodsFor: 'rendering' stamp: 'kph 3/22/2008 20:43'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html div class: 'group'; with: group! !

!MADivsRenderer methodsFor: 'rendering' stamp: 'kph 4/1/2008 22:27'!
renderLabel: aDescription
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label.
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label 
		class: (self classFor: aDescription);
		with: [ html render: aDescription label; text: ':' ]! !

!MADivsRenderer methodsFor: 'rendering' stamp: 'kph 3/22/2008 20:10'!
visitNonAccessingDescription: anObject! !

MADateInputComponent variableSubclass: #MADateInputShoreComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MADateInputShoreComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/7/2008 00:46'!
ShoreDatePicker

	^ Smalltalk at: #ShoreDatePicker ifAbsent: [ self error: 'Shore Components not loaded' ]! !

!MADateInputShoreComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/25/2008 03:27'!
renderEditorOn: html

	| picker |

	picker := self ShoreDatePicker in: html.
	picker isRequired: self description isRequired.
	picker on: #string of: self.! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/9/2008 18:16'!
chainTo: newAccessor

	^ MAChainAccessor on: self accessor: newAccessor
! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 8/14/2007 00:54'!
chainUnlinkLast

	^ nil! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/31/2008 14:43'!
cssClasses

   ^ self propertyAt: #cssClasses ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/31/2008 14:43'!
cssClasses: selectorOrAccessor

   self propertyAt: #cssClasses put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 8/14/2007 00:38'!
isChainAccessor

	^ false! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'EL 7/10/2008 12:21'!
key

	^ nil! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/10/2008 16:42'!
last

	^ self  ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:38'!
options

   ^ self propertyAt: #options ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:39'!
options: selectorOrAccessor

   self propertyAt: #options put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/21/2007 00:01'!
readonly 

   ^ self propertyAt: #readonly ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/21/2007 00:01'!
readonly: selectorOrAccessor

   self propertyAt: #readonly put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/14/2007 10:58'!
tooltip

   ^ self propertyAt: #tooltip ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/14/2007 10:58'!
tooltip: selectorOrAccessor

   self propertyAt: #tooltip put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 11:01'!
update 

   ^ self propertyAt: #update ifAbsent: [ self ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 10:56'!
update: selectorOrAccessor

   self propertyAt: #update put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 10:59'!
update: anObject to: aModel
	"Write ==anObject== to ==aModel== using the access-strategy of the receiver."

	self update write: anObject to: aModel! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:36'!
visible 

   ^ self propertyAt: #visible ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/30/2007 00:34'!
visible: selectorOrAccessor

   self propertyAt: #visible put: selectorOrAccessor asAccessor
	
 ! !

MAOneToManyComponent subclass: #MAOneToManyComponentPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAOneToManyComponentPlus commentStamp: 'kph 1/16/2008 01:26' prior: 0!
When you want an added component to be able to initialize from its container!

MAOneToManyComponentPlus subclass: #MAOneToManyComponentEditInPlace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAOneToManyComponentEditInPlace methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2008 17:56'!
add
 	 self value: (self value copyWith:  self newItem); refresh ! !

!MAOneToManyComponentEditInPlace methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2008 17:57'!
buildCommands
	commands := MACommandColumn new
				setReport: self report.

	self description isDefinitive
		ifFalse: [ commands
					addCommandOn: self selector: #remove:].

	self description isOrdered
		ifTrue: [ commands
					addCommandOn: self selector: #up:;
					addCommandOn: self selector: #down: ].

	^ commands! !

!MAOneToManyComponentPlus methodsFor: 'as yet unclassified' stamp: 'kph 1/16/2008 01:20'!
add
	| result |
	result := self newItem.
	result := self root call: (result asComponent
		addMessage: 'Add ' , self selected label;
		addValidatedForm;
		yourself).
	result isNil
		ifFalse: [ self value: (self value copyWith: result); refresh ]! !

!MAOneToManyComponentPlus methodsFor: 'as yet unclassified' stamp: 'kph 1/16/2008 04:15'!
newItem
 
	^	(self selected respondsTo: #parent:)
		ifTrue: [ self selected parent: self memento cache ]
		ifFalse: [ self selected new ]! !

MAOneToManyComponent subclass: #MAOneToManyDocumentsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAOneToManyDocumentsComponent commentStamp: 'kph 1/10/2008 12:13' prior: 0!
Component for uploading multiple files to one attribute of a model

usage:

descriptionDocuments

	^ MAToManyRelationDescription new
		classes: (Array with: WAExternalFileModel  "or custom subclass");
		accessor: #documents;
		componentClass: MAOneToManyDocumentsComponent;
 		label: 'Documents';
   		bePersisted;
		yourself!

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 05:15'!
add: it
 self value: (self value copyWith: it).
 self refresh.
! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 01:44'!
buildCommands
	commands := MACommandColumn new
				setReport: self report.

	self description isDefinitive
		ifFalse: [ commands
					addCommandOn: self selector: #rename: ;
					addCommandOn: self selector: #delete:    ].

	^ commands! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 03:17'!
buildReport
	^ (super buildReport)
		 showHeader: false;
		 tableEmpty: '(no documents)';
		 yourself
		
	! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 11:29'!
delete: a
	a finalize..
	^ self remove: a! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 04:49'!
isMultipart

	^ true! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 12:03'!
renderSelectButtonOn: html
	"html submitButton on: #upload of: self"
 
	html fileUpload
		on: #upload of: self.
	html submitButton
		text: 'upload'
 ! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 11:56'!
upload: aFile
	aFile ifNil: [ ^ self ].
	
 	self add: (
	
		self description commonClass new 
				mimetype: aFile contentType;
				filename: aFile fileName;
				contents: aFile contents;
				yourself ) ! !

!WATagBrush methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:20'!
classes: aList
	self class: (aList reduce: [ :a :b | a , ' ' , b ])! !

!MAValidatorVisitor methodsFor: '*magritte-scriptaculous-override' stamp: 'lr 7/12/2007 18:42'!
visitDescription: aDescription
	"Validate the current object using aDescription within an exception handler to avoid running further tests that might cause error-cascades."

	aDescription isVisible ifFalse: [ ^ self ].
	[ self validate: self object using: aDescription ]
		on: MAValidationError
		do: [ :err | err beResumable; pass ]! !

MADescribedColumn subclass: #MAColumnVisitor
	instanceVariableNames: 'object html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAColumnVisitor commentStamp: 'kph 1/10/2008 12:09' prior: 0!
This column kicks the rendering of the cell back to the description #renderCellContent: value on: html in: table!

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:31'!
isReadonly

	^ (description isReadonlyForItem: self value)! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 4/25/2008 07:22'!
lookupFormId

	self report announcer
	announce: ((WALookupUpwards selector: #ajaxFormId) detect: [ :comp | ^ comp ajaxFormId ])  
	
 ! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 17:30'!
renderCellContent: anObject on: htmlCanvas

	object := anObject.
	html := htmlCanvas.
	
	description acceptMagritte: self.
	
	object := nil.
	html := nil.! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:29'!
string
	^ self value isString
		ifTrue: [ self value ]
		ifFalse: [ description toString: self value ]! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:29'!
string: aString
	| value |
	value := [ description fromString: aString ]
		ifError: [ aString ].
	self value: value! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:19'!
value

 ^ (object readUsing: description) ifNil: [ description default ].
! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:20'!
value: v

 ^ object write: v using: description! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:29'!
visitDescription: desc  
 	
	html render: self string! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 15:29'!
visitFileDescription: desc  
 	html anchor
		url: (self value urlOn: html);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 17:34'!
visitNumberDescription: desc  
 	
	self visitDescription: desc! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 17:01'!
visitPriceDescription: desc  
	html render: desc currencySymbol.	
	
	html space.
	
	self visitDescription: desc.! !

!MAColumnVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 17:35'!
visitStringDescription: desc  
 	
	self visitDescription: desc! !

MAColumnVisitor subclass: #MAEditableColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAEditableColumn methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 17:40'!
visitBooleanDescription: desc  
 	
	html checkbox
		disabled: self isReadonly;
		on: #value of: self copy! !

!MAEditableColumn methodsFor: 'as yet unclassified' stamp: 'kph 3/16/2008 18:22'!
visitDescription: desc  
 
	| input |
	
	self isReadonly ifTrue: [ ^ super visitDescription: desc   ].
			
	input := html textInput.
	
	desc fieldSize ifNotNilDo: [ :size | input maxLength: size ].
	
	input on: #string of: self copy! !

!MAEditableColumn methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 17:41'!
visitToManyRelationDescription: desc  
 	
! !

MAEditableColumn subclass: #MAEditableColumnAutoCompleting
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:46'!
filter
	" #left #right #substring (default) #match"
	
	^ description propertyAt: #filter ifAbsent: [ #substring ]! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:20'!
isAutoSelect

	^ description propertyAt: #autoSelect ifAbsent: false! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:20'!
isUpdating

	^ (description accessor propertyAt: #update ifAbsent: [nil]) notNil! !

!MAEditableColumnAutoCompleting methodsFor: 'filters' stamp: 'kph 3/17/2008 14:48'!
left
	^ self list select: [ :each | (each asString findString: self string startingAt: 1 caseSensitive: false) = 1 ].! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:56'!
list

	self listDescription ifNotNilDo: [ :desc | ^ object readUsing: desc  ].
	 
	^ object readUsing: (MADescription basicNew accessor: (description accessor options ifNil: [ ^ #() ]) ).
	
 ! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:55'!
listDescription
	 
	^ object class perform: (self listDescriptionSelector ifNil:[ ^nil ])! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:55'!
listDescriptionSelector

	^ self description propertyAt: #listDescriptionSelector ifAbsent: nil! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:45'!
listFiltered

	^ self perform: self filter! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:47'!
listMax
	^ self description propertyAt: #listMax ifAbsent: [ self listMaxDefault ]! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:47'!
listMaxDefault
	^  10! !

!MAEditableColumnAutoCompleting methodsFor: 'filters' stamp: 'kph 3/17/2008 14:48'!
match

	| match |
	
	match := ('*', self string ,'*') copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAEditableColumnAutoCompleting methodsFor: 'filters' stamp: 'kph 4/16/2008 14:20'!
matchLeft

	| match |
	
	match := (self string ,'*') copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAEditableColumnAutoCompleting methodsFor: 'filters' stamp: 'kph 4/16/2008 14:20'!
matchRight

	| match |
	
	match := ('*', self string) copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:45'!
renderListOn: aCanvas

	| items |
	
	items := self listFiltered.

	aCanvas unorderedList list: (items first: (items size min: self listMax))! !

!MAEditableColumnAutoCompleting methodsFor: 'filters' stamp: 'kph 3/17/2008 14:48'!
right

	| match |
	
	match := ('*', self string) copyReplaceAll: '**' with: '*'.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAEditableColumnAutoCompleting methodsFor: 'filters' stamp: 'kph 3/17/2008 14:49'!
substring
	^ self list select: [ :each | each asString includesSubstring: self string caseSensitive: false ].
	
 ! !

!MAEditableColumnAutoCompleting methodsFor: 'as yet unclassified' stamp: 'kph 3/17/2008 14:41'!
visitDescription: desc  
 
	| input p whenSelected callbackTarget |
 	
	self isReadonly ifTrue: [ ^ super visitDescription: desc   ].
	
	id := html nextId.
	input := html textInput id: id.
	
	desc fieldSize ifNotNilDo: [ :size | input maxLength: size ].

	callbackTarget := self copy.
	
	input on: #string of: callbackTarget.
 
"	p := self parent. "
 
	"	exampleText: self exampleText; "
		"onChange: (html request
					triggerFormElement: input);"
	
	whenSelected := html request.
					
"	self isUpdating ifTrue: [
		 
		whenSelected 
			triggerFormElement: id; 
			onSuccess: (html updater id: (p id); callback: [ :r | self log info: p id.  p updateContentOn: r] )
	].  
"	
	html div 
		class: 'autocomplete';
		script: (html autocompleter
			element: id;
			autoSelect: self isAutoSelect;
			onSelected: whenSelected;
			on: #renderListOn: of: callbackTarget)
		 ! !

MAListCompositonComponent subclass: #MAListCompositonComponentSU
	instanceVariableNames: 'id availableId selectedId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
formId

	^ self labelId, '-f'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorAvailableOn: html

	html select
		attributes: self attributes;
		id: availableId;
		size: 6; style: 'width: 250px';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonAddOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: availableId;
					callback: [ :r | self add; updateEditorOn: r ];
					return: false);
		with: '>>'.
	html break.
	html button
		onClick: (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self remove; updateEditorOn: r ];
					return: false);
		with: '<<'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonOrderOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveUp; updateEditorOn: r ];
					return: false);
		text: 'up'.
	html break.
	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveDown; updateEditorOn: r ]; 
					return: false);
		text: 'down'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:13'!
renderEditorOn: html 
	id := html nextId.
	availableId := html nextId.
	selectedId := html nextId.
	html div
		id: id;
		with: 
			 [self updateEditorOn: html] ! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorSelectedOn: html
 	html select
		attributes: self attributes;
		id: selectedId;
		size: 6; style: 'width: 250px';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/16/2007 08:56'!
updateEditorOn: html
		super renderEditorOn: html! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
updateId

	^ self labelId, '-u'! !

MASelectListComponent subclass: #MASelectListComponentSU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MASelectListComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 2/25/2008 21:36'!
options
	 
	^ self memento model readUsing: (MADescription basicNew accessor: (self description accessor options ifNil: [ ^ self description options ]) ).
	
 ! !

!MASelectListComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 3/8/2008 00:23'!
renderEditorOn: html

	

	html select
		attributes: self attributes;
		id: self labelId;
		list: self options;
		selected: self value;
		callback: [ :value | self value: value ];
		onChange: (html updater 
						id: (parent id); 
						triggerFormElement: (self labelId);
						callback: [ :r | self log info: parent id.   parent updateContentOn: r] );
		labels: [ :value | self labelForOption: value ]
		
 ! !

!MAOptionDescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 08:38'!
optionsFor: item

	^ item readUsing: (MADescription basicNew accessor: (self accessor options ifNil: [ ^ self options ]))

! !

!MADescriptionComponent methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 09:14'!
isReadonly
	(self isRoot not and: [self parent isReadonly]) ifTrue: [^ true].
	^ self description isReadonlyForItem: self memento ! !

!MASelectorAccessor methodsFor: '*magritte-scriptaculous' stamp: 'EL 7/10/2008 12:21'!
key
	^self selector! !

!MADescription methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:06'!
accessor: anAccessor
	accessor := anAccessor asAccessor! !

!MADescription methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/31/2008 15:18'!
cssClass: aString
	(self propertyAt: #cssClasses ifAbsentPut: [ self cssClassesDefault ])
		add: aString! !

!MADescription methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 6/4/2008 01:47'!
cssClasses
	^ self propertyAt: #cssClasses ifAbsent: [ self cssClassesDefault ]! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/10/2008 19:51'!
cssClassesDefault

	  | classes |
 	
	classes := self class defaultCssClasses.
	self accessor last key ifNotNilDo: [ :css  | classes add:  'ma-', css ].
			
	^ classes! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/31/2008 15:08'!
cssClassesForDynamicItem: item
	 
	^ (item readUsing: (MADescription basicNew accessor: (self accessor cssClasses ifNil: [ ^ #() ]))) ifNil: [ #() ]
	 ! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/31/2008 15:30'!
cssClassesForItem: item
	 
	 | classes |

	classes := OrderedCollection withAll: self cssClasses.	
	
	item ifNil: [ ^ classes ].
	
	classes addAll: (self cssClassesForDynamicItem: item).
	
	(self isReadonlyForItem: item)
		ifTrue: [ classes add: 'readonly' ].
	self isRequired
		ifTrue: [ classes add: 'required' ].

	^ classes! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:12'!
isReadonlyForItem: item
	 
	^  item readUsing: (MADescription basicNew accessor: (self accessor readonly ifNil: [ ^ self isReadonly ]))! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 2/3/2008 21:06'!
isVisibleForItem: item
	 
	^ self isVisible and: [ item readUsing: 
		(MADescription basicNew accessor: (self accessor visible ifNil: [ ^ self isVisible ]))]  
 ! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 01:51'!
tooltipForItem: item
	 
	^ item readUsing: (MADescription basicNew accessor: (self accessor tooltip ifNil: [ ^ self comment ]))! !

!MATableRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'lr 4/20/2007 13:18'!
renderControl: aDescription
	html tableData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!MATableRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 01:49'!
renderElement: aDescription
	html tableRow
	 	title: (aDescription tooltipForItem:  (self childAt: aDescription) model);
		with: [ super renderElement: aDescription ]! !

!MAReport methodsFor: '*magritte-scriptaculous-rendering-override' stamp: 'kph 6/4/2008 01:03'!
renderTableBodyOn: html
	self visible isEmpty
		ifTrue: [
			html tableRow
				class: 'empty';
				with: [
					html tableData
						colSpan: self visibleColumns size;
						with: self tableEmpty ] ]
		ifFalse: [
			self visible keysAndValuesDo: [ :index :row |
				html tableRow
					class: (self rowStyleForNumber: index);
					with: [
						self visibleColumns keysAndValuesDo: [ :colIndex :col |
							col renderCell: row row: index column: colIndex on: html ] ] ] ]! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:07'!
accessor: anAccessor
	accessor := anAccessor asAccessor! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/10/2008 16:38'!
chainUnlinkLast

	| lastButOne |
	
	lastButOne := self lastButOne.
	
	lastButOne = self ifTrue: [ ^ self next ].

	self lastButOne: lastButOne next.
	
	^ self

 
"
	 (MAChainAccessor accessors: #(a b)) chainUnlinkLast	  
"! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 8/14/2007 00:38'!
isChainAccessor

	^ true! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/10/2008 16:51'!
key

^ self last key! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/9/2008 18:23'!
last

	^ self lastButOne ifNil: [ self ] ifNotNilDo: [ :lbo | lbo accessor ].




! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/9/2008 18:22'!
lastButOne

	| lbo |
	
	lbo := self.
	[ lbo accessor isChainAccessor ] whileTrue: [ lbo := lbo accessor ].

	^ lbo
	
! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 6/9/2008 18:41'!
lastButOne: anAccessor
	
	| lbo lbt |
	lbo := self.
	[ lbo accessor isChainAccessor ] whileTrue: [ lbt := lbo. lbo := lbo accessor ].

	^ lbt ifNil: [ anAccessor ] ifNotNil: [ lbt accessor: anAccessor. self ]
	
	
! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:07'!
next: anAccessor
	next := anAccessor asAccessor! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 2/3/2008 23:47'!
update: anObject to: aModel
	"Write ==anObject== to ==aModel== using the access-strategy of the receiver."
 
	self next update: anObject to: (self accessor read: aModel)! !

!MAContainerComponent methodsFor: '*magritte-scriptaculous' stamp: 'kph 4/25/2008 07:12'!
ajaxFormId

^ self ajaxId: 'form'
! !

!MAContainerComponent methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 6/4/2008 01:45'!
renderContentOn: html
	html div
		id: self id;
		with: [ 	self updateContentOn: html ]! !

!MAContainerComponent methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/30/2008 22:36'!
updateContentOn: html
 
	self description componentRenderer
		component: self on: html! !
